package com.seeyon.apps.govdoc.controller;

import com.seeyon.apps.govdoc.manager.GovdocLeaderAndPermissionRelationManager;
import com.seeyon.apps.govdoc.po.GovdocLeaderPermissionRelation;
import com.seeyon.apps.govdoc.po.GovdocLeaderSerialShortname;
import com.seeyon.ctp.common.AppContext;
import com.seeyon.ctp.common.controller.BaseController;
import com.seeyon.ctp.common.log.CtpLogFactory;
import com.seeyon.ctp.util.FlipInfo;
import com.seeyon.ctp.util.UUIDLong;
import org.apache.commons.logging.Log;
import org.apache.logging.log4j.util.Strings;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.*;

public class GovdocLeaderPermissionController extends BaseController {
    private static final Log LOGGER = CtpLogFactory.getLog(GovdocLeaderPermissionController.class);
    private GovdocLeaderAndPermissionRelationManager govdocLeaderAndPermissionRelationManager;

    public void setGovdocLeaderAndPermissionRelationManager(GovdocLeaderAndPermissionRelationManager govdocLeaderAndPermissionRelationManager) {
        this.govdocLeaderAndPermissionRelationManager = govdocLeaderAndPermissionRelationManager;
    }
    /**
     * 领导节点权限编辑
     * @param request
     * @param response
     * @return
     * @throws Exception
     */
    public ModelAndView leaderEdit(HttpServletRequest request, HttpServletResponse response)throws Exception{
        ModelAndView mav = new ModelAndView("govdoc/leaderpishiset/leaderEdit");
        FlipInfo flipInfo = new FlipInfo();
        String id = request.getParameter("id");
        String flag = request.getParameter("flag");
        mav.addObject("flag",flag);
        GovdocLeaderPermissionRelation relation = null;
        if(id != null && !"".equals(id) && ("edit".equals(flag)||"readonly".equals(flag))){
            Map<String, Object> map = new HashMap<String, Object>();
            map.put("id", Long.valueOf(id));
            List<GovdocLeaderPermissionRelation> list = new ArrayList<GovdocLeaderPermissionRelation>();
            flipInfo = govdocLeaderAndPermissionRelationManager.findById(flipInfo,map);
            list  = flipInfo.getData();
            if(!list.isEmpty()){
                relation = list.get(0);
            }
            if(relation != null ){
                mav.addObject("id",relation.getId());
                mav.addObject("leaderId",relation.getLeaderId());
                mav.addObject("leaderName",govdocLeaderAndPermissionRelationManager.LeaderIdStrTransName(relation.getLeaderId()));
				/*
				 * mav.addObject("permissionId",relation.getPermissionId());
				 * mav.addObject("permissionName",govdocLeaderAndPermissionRelationManager.
				 * permissionIdStrTransName(relation.getPermissionId()));
				 * mav.addObject("category",relation.getCategory());
				 */
                mav.addObject("permissionRangeDidID",relation.getPermissionRangeDid());
                mav.addObject("permissionRangeDidName",govdocLeaderAndPermissionRelationManager.permissionIdStrTransName(relation.getPermissionRangeDid()));
                mav.addObject("permissionRangeRecId",relation.getPermissionRangeRec());
                mav.addObject("permissionRangeRecName",govdocLeaderAndPermissionRelationManager.permissionIdStrTransName(relation.getPermissionRangeRec()));
                mav.addObject("permissionRangeSigId",relation.getPermissionRangeSig());
                mav.addObject("permissionRangeSigName",govdocLeaderAndPermissionRelationManager.permissionIdStrTransName(relation.getPermissionRangeSig()));
                mav.addObject("orgAccountId",relation.getOrgAccountId());
            }
        }
        return mav;
    }
    /**
     * 新增/修改领导权限
     * @author zc
     * @param request
     * @param response
     * @return
     * @throws Exception
     */
    public ModelAndView saveOrEditLeaderPermission(HttpServletRequest request,HttpServletResponse response)throws Exception{
        try {
            // 获取前端参数
            String id =  request.getParameter("id");
            String flag =  request.getParameter("flag");
            String leaderId =  request.getParameter("leaderId");
            Long sOrgAccountId =  Long.valueOf(request.getParameter("orgAccountId"));
            String leaderName = request.getParameter("leaderName");
            //发文
            String permissionRangeDid = request.getParameter("permissionRangeDid");
            //收文
            String permissionRangeRec = request.getParameter("permissionRangeRec");
           // 签报
            String permissionRangeSig = request.getParameter("permissionRangeSig");
            Long createPersonId = AppContext.currentUserId();
            if(!AppContext.getCurrentUser().getAccountId().toString().equals(sOrgAccountId)) {
                sOrgAccountId = AppContext.getCurrentUser().getAccountId();
            }
            // 构建 领导权限
            GovdocLeaderPermissionRelation govdocLPR = new GovdocLeaderPermissionRelation();
            if(Strings.isNotBlank(id)&& "edit".equals(flag) ){
            	govdocLPR = govdocLeaderAndPermissionRelationManager.getById(Long.valueOf(id));
            }else{
                govdocLPR.setId(UUIDLong.longUUID());
                govdocLPR.setCreateDate(new Date());
                govdocLPR.setLeaderId(leaderId);
                govdocLPR.setCreatePerson(String.valueOf(AppContext.currentUserId()));
                govdocLPR.setLeader(leaderName);
                govdocLPR.setOrgAccountId(sOrgAccountId);
            }
             if("overlay".equals(flag) && leaderId!=null &&!"".equals(leaderId.toString())){
            	 govdocLeaderAndPermissionRelationManager.deleteLPRByLeaderNewId(leaderId,sOrgAccountId); 
            }
            govdocLPR.setUpdateTime(new Date());
            govdocLPR.setPermissionRangeDid(permissionRangeDid);
            govdocLPR.setPermissionRangeRec(permissionRangeRec);
            govdocLPR.setPermissionRangeSig(permissionRangeSig);
            govdocLeaderAndPermissionRelationManager.saveOrEdit(govdocLPR);
        } catch(Exception e) {
            LOGGER.error("添加保存错误", e);
        }
        return null;
    }

}
