package com.seeyon.apps.govdoc.controller;

import com.seeyon.apps.govdoc.manager.GovdocFormManager;
import com.seeyon.apps.govdoc.manager.GovdocPishiManager;
import com.seeyon.apps.govdoc.manager.GovdocSummaryManager;
import com.seeyon.apps.govdoc.po.EdocUserLeaderRelation;
import com.seeyon.apps.govdoc.util.GovdocUtil;
import com.seeyon.ctp.common.AppContext;
import com.seeyon.ctp.common.affair.manager.AffairManager;
import com.seeyon.ctp.common.content.mainbody.MainbodyManager;
import com.seeyon.ctp.common.controller.BaseController;
import com.seeyon.ctp.common.exceptions.BusinessException;
import com.seeyon.ctp.common.i18n.ResourceUtil;
import com.seeyon.ctp.common.log.CtpLogFactory;
import com.seeyon.ctp.common.permission.bo.DetailAttitude;
import com.seeyon.ctp.common.permission.bo.Permission;
import com.seeyon.ctp.common.permission.manager.PermissionManager;
import com.seeyon.ctp.common.po.affair.CtpAffair;
import com.seeyon.ctp.form.api.FormApi4Cap3;
import com.seeyon.ctp.form.bean.FormAuthViewBean;
import com.seeyon.ctp.form.bean.FormAuthViewFieldBean;
import com.seeyon.ctp.form.bean.FormFieldBean;
import com.seeyon.ctp.form.bean.FormFieldComBean;
import com.seeyon.ctp.form.util.permission.factory.PermissionFatory;
import com.seeyon.ctp.organization.bo.V3xOrgMember;
import com.seeyon.ctp.organization.manager.OrgManager;
import com.seeyon.ctp.util.DateUtil;
import com.seeyon.ctp.util.Strings;
import com.seeyon.ctp.util.json.JSONUtil;
import com.seeyon.v3x.edoc.domain.EdocSummary;
import org.apache.commons.logging.Log;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.*;

public class GovdocTransInstructionController extends BaseController {
    private static final Log LOGGER = CtpLogFactory.getLog(GovdocLeaderPermissionController.class);
    private GovdocPishiManager govdocPishiManager;
    private MainbodyManager mainbodyManager;
    private AffairManager affairManager;
    private GovdocFormManager govdocFormManager;
    private FormApi4Cap3 formApi4Cap3;
    private PermissionManager permissionManager;
    private GovdocSummaryManager govdocSummaryManager;

    public void setGovdocSummaryManager(GovdocSummaryManager govdocSummaryManager) {
        this.govdocSummaryManager = govdocSummaryManager;
    }

    public void setPermissionManager(PermissionManager permissionManager) {
        this.permissionManager = permissionManager;
    }

    public void setGovdocPishiManager(GovdocPishiManager govdocPishiManager) {
        this.govdocPishiManager = govdocPishiManager;
    }

    public void setMainbodyManager(MainbodyManager mainbodyManager) {
        this.mainbodyManager = mainbodyManager;
    }

    public void setAffairManager(AffairManager affairManager) {
        this.affairManager = affairManager;
    }

    public void setGovdocFormManager(GovdocFormManager govdocFormManager) {
        this.govdocFormManager = govdocFormManager;
    }

    public void setFormApi4Cap3(FormApi4Cap3 formApi4Cap3) {
        this.formApi4Cap3 = formApi4Cap3;
    }

    /**
     *
     * 代录批示
     * @param request
     * @param response
     * @return
     * @throws Exception
     */
    public ModelAndView transInstructions (HttpServletRequest request, HttpServletResponse response)throws Exception{
        ModelAndView mav = new ModelAndView("govdoc/leaderpishiset/instructionDetails");
        String affairId = Strings.toHTML(request.getParameter("affairId"));
        //CtpAffair affair = affairManager.get(Long.valueOf(affairId));

        List<EdocUserLeaderRelation> list = govdocPishiManager.getEdocUserLeaderRelation(AppContext.currentUserId());
        //根据人员序号排序
//        Collections.sort(list, new Comparator<EdocUserLeaderRelation>() {
//            @Override
//            public int compare(EdocUserLeaderRelation edoc1, EdocUserLeaderRelation edoc2) {
//                OrgManager orgManager = (OrgManager) AppContext.getBean("orgManager");
//                String typeAndId1 = edoc1.getLeaderId();
//                String typeAndId2 = edoc2.getLeaderId();
//                String[] data1 = typeAndId1.split("[|]");
//                String[] data2 = typeAndId2.split("[|]");
//                if (data1.length  == 2&&data2.length == 2) {
//                    try {
//                        V3xOrgMember member1 = orgManager.getMemberById(Long.valueOf(data1[1]));
//                        V3xOrgMember member2 = orgManager.getMemberById(Long.valueOf(data2[1]));
//                        int i = member1.getSortId().intValue() - member2.getSortId().intValue();
//                        return i;
//                    } catch (NumberFormatException e) {
//
//                    } catch (BusinessException e) {
//
//                    }
//                }
//
//                return 0;
//            }
//
//        });
        
        mav.addObject("pishiUsers", list);
        mav.addObject("now", DateUtil.getDate("yyyy-MM-dd HH:mm"));
        //mav.addObject("affair", affair);
        return mav;
    }
}
